## mingw-w64-alembic-1.8.5-2.src.tar.zst

=== lib/Alembic/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Sony Pictures Imageworks, nor
## Industrial Light & Magic, nor the names of their contributors may be used
## to endorse or promote products derived from this software without specific
## prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

ADD_SUBDIRECTORY(Util)
ADD_SUBDIRECTORY(AbcCoreAbstract)
ADD_SUBDIRECTORY(AbcCoreOgawa)
IF (USE_HDF5)
    ADD_SUBDIRECTORY(AbcCoreHDF5)
ENDIF()
ADD_SUBDIRECTORY(Abc)
ADD_SUBDIRECTORY(AbcCoreFactory)
ADD_SUBDIRECTORY(AbcCoreLayer)
ADD_SUBDIRECTORY(AbcGeom)
ADD_SUBDIRECTORY(AbcCollection)
ADD_SUBDIRECTORY(AbcMaterial)
ADD_SUBDIRECTORY(Ogawa)

ADD_LIBRARY(Alembic ${LIB_TYPE} ${CXX_FILES})

TARGET_INCLUDE_DIRECTORIES(Alembic
    PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/lib>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/lib>
    $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>
    ${ALEMBIC_ILMBASE_INCLUDE_DIRECTORY}
    ${Boost_INCLUDE_DIRS}
    PRIVATE
    ${HDF5_INCLUDE_DIRS}
    )

IF (ALEMBIC_SHARED_LIBS)
  SET_TARGET_PROPERTIES(Alembic PROPERTIES DEFINE_SYMBOL ALEMBIC_EXPORTS
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    VERSION ${PROJECT_VERSION})

  if (ALEMBIC_USING_IMATH_3)
    if (APPLE OR UNIX)
      set_target_properties(Alembic PROPERTIES INSTALL_RPATH "$<TARGET_FILE_DIR:${ALEMBIC_ILMBASE_LIBS}>")
    endif ()
  endif ()
ENDIF()


TARGET_LINK_LIBRARIES(Alembic
    LINK_PUBLIC
    ${ALEMBIC_ILMBASE_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${EXTERNAL_MATH_LIBS}
    LINK_PRIVATE
    ${HDF5_LIBRARIES}
    ${ZLIB_LIBRARY}
  )

SET( ALEMBIC_LIB_INSTALL_DIR lib CACHE STRING "Where to install the Alembic libs")
INSTALL(TARGETS Alembic
        EXPORT AlembicTargets
        LIBRARY DESTINATION ${ALEMBIC_LIB_INSTALL_DIR}
        ARCHIVE DESTINATION ${ALEMBIC_LIB_INSTALL_DIR}
        RUNTIME DESTINATION ${ALEMBIC_LIB_INSTALL_DIR})

#-******************************************************************************
# PACKAGE EXPORTS
#-******************************************************************************

set(alembic_targets_file "${PROJECT_NAME}Targets.cmake")

SET(ConfigPackageLocation lib/cmake/Alembic CACHE PATH
        "Where to install the Alembic's cmake files")

INCLUDE(CMakePackageConfigHelpers)

configure_package_config_file(AlembicConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/AlembicConfig.cmake"
     INSTALL_DESTINATION ${ConfigPackageLocation}
     )

WRITE_BASIC_PACKAGE_VERSION_FILE(
    "${CMAKE_CURRENT_BINARY_DIR}/AlembicConfigVersion.cmake"
    VERSION
    ${PROJECT_VERSION}
    COMPATIBILITY
    AnyNewerVersion
    )

EXPORT(TARGETS
    Alembic
    FILE
    "${CMAKE_CURRENT_BINARY_DIR}/${alembic_targets_file}"
    NAMESPACE
    Alembic::
    )

INSTALL(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/AlembicConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/AlembicConfigVersion.cmake"
    DESTINATION
    ${ConfigPackageLocation}
    )

IF (DOCS_PATH)
    IF(NOT DOXYGEN_FOUND)
         MESSAGE(FATAL_ERROR "Doxygen is needed to build the documentation.")
    ENDIF()

    SET(DOXYGEN_EXCLUDE_PATTERNS */Tests/*)
    SET(DOXYGEN_OUTPUT_DIRECTORY ${DOCS_PATH})
    SET(DOXYGEN_GENERATE_HTML YES)
    DOXYGEN_ADD_DOCS( doxygen ${CMAKE_CURRENT_SOURCE_DIR} )

ENDIF()


INSTALL(EXPORT
    AlembicTargets
    FILE
    ${alembic_targets_file}
    NAMESPACE
    Alembic::
    DESTINATION
    ${ConfigPackageLocation}
    )

=== lib/Alembic/Abc/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    Abc/ArchiveInfo.cpp
    Abc/ErrorHandler.cpp
    Abc/IArchive.cpp
    Abc/IArrayProperty.cpp
    Abc/ICompoundProperty.cpp
    Abc/IObject.cpp
    Abc/ISampleSelector.cpp
    Abc/IScalarProperty.cpp
    Abc/OArchive.cpp
    Abc/OArrayProperty.cpp
    Abc/OCompoundProperty.cpp
    Abc/OObject.cpp
    Abc/OScalarProperty.cpp
    Abc/Reference.cpp
    Abc/SourceName.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES
    All.h
    Base.h
    ErrorHandler.h
    Foundation.h
    Argument.h
    ArchiveInfo.h
    IArchive.h
    IArrayProperty.h
    IBaseProperty.h
    ICompoundProperty.h
    IObject.h
    ISampleSelector.h
    IScalarProperty.h
    ISchema.h
    ISchemaObject.h
    ITypedArrayProperty.h
    ITypedScalarProperty.h
    OArchive.h
    OArrayProperty.h
    OBaseProperty.h
    OCompoundProperty.h
    OObject.h
    OScalarProperty.h
    OSchema.h
    OSchemaObject.h
    OTypedArrayProperty.h
    OTypedScalarProperty.h
    Reference.h
    SourceName.h
    TypedArraySample.h
    TypedPropertyTraits.h
    DESTINATION include/Alembic/Abc
)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== lib/Alembic/AbcCollection/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcCollection/OCollections.cpp
    AbcCollection/ICollections.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES
    All.h
    SchemaInfoDeclarations.h
    OCollections.h
    ICollections.h
    DESTINATION include/Alembic/AbcCollection
)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== lib/Alembic/AbcCoreOgawa/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2013-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcCoreOgawa/AprImpl.cpp
    AbcCoreOgawa/ApwImpl.cpp
    AbcCoreOgawa/ArImpl.cpp
    AbcCoreOgawa/AwImpl.cpp
    AbcCoreOgawa/CprData.cpp
    AbcCoreOgawa/CprImpl.cpp
    AbcCoreOgawa/CpwData.cpp
    AbcCoreOgawa/CpwImpl.cpp
    AbcCoreOgawa/MetaDataMap.cpp
    AbcCoreOgawa/OrData.cpp
    AbcCoreOgawa/OrImpl.cpp
    AbcCoreOgawa/OwData.cpp
    AbcCoreOgawa/OwImpl.cpp
    AbcCoreOgawa/ReadUtil.cpp
    AbcCoreOgawa/ReadWrite.cpp
    AbcCoreOgawa/SprImpl.cpp
    AbcCoreOgawa/SpwImpl.cpp
    AbcCoreOgawa/StreamManager.cpp
    AbcCoreOgawa/WriteUtil.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES All.h ReadWrite.h
        DESTINATION include/Alembic/AbcCoreOgawa)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== lib/Alembic/AbcMaterial/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcMaterial/OMaterial.cpp
    AbcMaterial/IMaterial.cpp
    AbcMaterial/MaterialFlatten.cpp
    AbcMaterial/MaterialAssignment.cpp
    AbcMaterial/InternalUtil.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES
    All.h
    SchemaInfoDeclarations.h
    OMaterial.h
    IMaterial.h
    MaterialFlatten.h
    MaterialAssignment.h
    DESTINATION include/Alembic/AbcMaterial
)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== lib/Alembic/Abc/Tests/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/lib ${PROJECT_BINARY_DIR}/lib)

ADD_EXECUTABLE(Abc_Test1 test1.cpp)
TARGET_LINK_LIBRARIES(Abc_Test1 Alembic)

ADD_EXECUTABLE(Abc_ObjectsAndProperties_Test2 ObjectsAndPropertiesTest.cpp)
TARGET_LINK_LIBRARIES(Abc_ObjectsAndProperties_Test2 Alembic)

ADD_TEST(Abc_TEST1 Abc_Test1)
ADD_TEST(Abc_Objects_and_Properties_TEST2 Abc_ObjectsAndProperties_Test2)

ADD_EXECUTABLE(Abc_CompileTests CompileTest.cpp)
TARGET_LINK_LIBRARIES(Abc_CompileTests Alembic)
ADD_TEST(Abc_Compile_TEST Abc_CompileTests)

ADD_EXECUTABLE(Abc_ObjectTests ObjectTests.cpp)
TARGET_LINK_LIBRARIES(Abc_ObjectTests Alembic)
ADD_TEST(Abc_Object_TEST Abc_ObjectTests)

ADD_EXECUTABLE(Abc_PropertyTests PropertyTests.cpp)
TARGET_LINK_LIBRARIES(Abc_PropertyTests Alembic)
ADD_TEST(Abc_Property_TEST Abc_PropertyTests)

ADD_EXECUTABLE(Abc_UniformPropertyTest UniformPropertyTest.cpp)
TARGET_LINK_LIBRARIES(Abc_UniformPropertyTest Alembic)
ADD_TEST(Abc_Uniform_Property_TEST Abc_UniformPropertyTest)

ADD_EXECUTABLE(Abc_IdentityPropertyTest IdentityPropertyTest.cpp)
TARGET_LINK_LIBRARIES(Abc_IdentityPropertyTest Alembic)
ADD_TEST(Abc_Identity_Property_TEST Abc_IdentityPropertyTest)

ADD_EXECUTABLE(Abc_ArrayPropertyTest ArrayPropertyTest.cpp)
TARGET_LINK_LIBRARIES(Abc_ArrayPropertyTest Alembic)
ADD_TEST(Abc_Array_Property_TEST Abc_ArrayPropertyTest)

ADD_EXECUTABLE(Abc_InstanceTest InstanceTest.cpp)
TARGET_LINK_LIBRARIES(Abc_InstanceTest Alembic)
ADD_TEST(Abc_Instance_TEST Abc_InstanceTest)

ADD_EXECUTABLE(Abc_ArchiveTest ArchiveTest.cpp)
TARGET_LINK_LIBRARIES(Abc_ArchiveTest Alembic)
ADD_TEST(Abc_Archive_TEST Abc_ArchiveTest)

ADD_EXECUTABLE(Abc_CyclicPropertyTest CyclicPropertyTest.cpp)
TARGET_LINK_LIBRARIES(Abc_CyclicPropertyTest Alembic)
ADD_TEST(Abc_Cyclic_Property_TEST Abc_CyclicPropertyTest)

ADD_EXECUTABLE(Abc_ParentingTest ParentingTest.cpp)
TARGET_LINK_LIBRARIES(Abc_ParentingTest Alembic)
ADD_TEST(Abc_Parenting_TEST Abc_ParentingTest)

ADD_EXECUTABLE(Abc_OctessenceBug17 OctessenceBug17.cpp)
TARGET_LINK_LIBRARIES(Abc_OctessenceBug17 Alembic)
ADD_TEST(Abc_OctessenceBug17_TEST Abc_OctessenceBug17)

ADD_EXECUTABLE(Abc_OctessenceBug16 OctessenceBug16.cpp)
TARGET_LINK_LIBRARIES(Abc_OctessenceBug16 Alembic)
ADD_TEST(Abc_OctessenceBug16_TEST Abc_OctessenceBug16)

ADD_EXECUTABLE(Abc_CacheControlTest CacheControlTest.cpp)
TARGET_LINK_LIBRARIES(Abc_CacheControlTest Alembic)
ADD_TEST(Abc_CacheControl_TEST Abc_CacheControlTest)

ADD_EXECUTABLE(Abc_RedundantDataPathsTest RedundantDataTest.cpp)
TARGET_LINK_LIBRARIES(Abc_RedundantDataPathsTest Alembic)
ADD_TEST(Abc_RedundantDataPaths_TEST Abc_RedundantDataPathsTest)

file(COPY fuzzer_issue26643.abc DESTINATION .)

=== lib/Alembic/AbcGeom/Tests/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/lib ${PROJECT_BINARY_DIR}/lib)

ADD_EXECUTABLE(AbcGeom_PolyMeshTest
               MeshData.h
               MeshData.cpp
               PolyMeshTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_PolyMeshTest Alembic)
ADD_TEST(AbcGeom_PolyMesh_TEST AbcGeom_PolyMeshTest)

ADD_EXECUTABLE(AbcGeom_HelperLibTest
                HelperLibTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_HelperLibTest Alembic)
ADD_TEST(AbcGeom_HelperLib_TEST AbcGeom_HelperLibTest)

ADD_EXECUTABLE(AbcGeom_PointsTest
               PointsTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_PointsTest Alembic)
ADD_TEST(AbcGeom_Points_TEST AbcGeom_PointsTest)

ADD_EXECUTABLE(AbcGeom_NurbsTest
               NurbsData.h
               NurbsData.cpp
               NurbsTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_NurbsTest Alembic)
ADD_TEST(AbcGeom_Nurbs_TEST AbcGeom_NurbsTest)

ADD_EXECUTABLE(AbcGeom_SubDTest
               MeshData.h
               MeshData.cpp
               SubDTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_SubDTest Alembic)
ADD_TEST(AbcGeom_SubD_TEST AbcGeom_SubDTest)

ADD_EXECUTABLE(AbcGeom_SubDFaceSetTest
               MeshData.h
               MeshData.cpp
               SubDFaceSetTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_SubDFaceSetTest Alembic)
ADD_TEST(AbcGeom_SubDFaceSet_TEST AbcGeom_SubDFaceSetTest)

ADD_EXECUTABLE(AbcGeom_SchemaMatchingTest
               SchemaMatchingTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_SchemaMatchingTest Alembic)
ADD_TEST(AbcGeom_SchemaMatching_TEST AbcGeom_SchemaMatchingTest)

ADD_EXECUTABLE(AbcGeom_XformTest
               XformTests.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_XformTest  Alembic)
ADD_TEST(AbcGeom_Xform_TEST  AbcGeom_XformTest)

ADD_EXECUTABLE(AbcGeom_XformTest2
               XformTests2.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_XformTest2  Alembic)
ADD_TEST(AbcGeom_Xform2_TEST  AbcGeom_XformTest2)

ADD_EXECUTABLE(AbcGeom_CurvesTest
               CurvesData.h
               CurvesData.cpp
               CurvesTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_CurvesTest Alembic)
ADD_TEST(AbcGeom_Curves_TEST AbcGeom_CurvesTest)

ADD_EXECUTABLE(AbcGeom_GeomBaseTest
               CurvesData.h
               CurvesData.cpp
               GeomBaseTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_GeomBaseTest Alembic)
ADD_TEST(AbcGeom_GeomBase_TEST AbcGeom_GeomBaseTest)

ADD_EXECUTABLE(AbcGeom_TransformingMeshTest
               MeshData.h
               MeshData.cpp
               TransformingMeshTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_TransformingMeshTest Alembic)
ADD_TEST(AbcGeom_TransformingMesh_TEST AbcGeom_TransformingMeshTest)

ADD_EXECUTABLE(AbcGeom_CompileTest
               CompileTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_CompileTest Alembic)
ADD_TEST(AbcGeom_CompileTest_TEST AbcGeom_CompileTest)

ADD_EXECUTABLE(AbcGeom_LightTest
               LightTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_LightTest Alembic)
ADD_TEST(AbcGeom_LightTest_TEST AbcGeom_LightTest)

ADD_EXECUTABLE(AbcGeom_CameraTest
               CameraTest.cpp)
TARGET_LINK_LIBRARIES(AbcGeom_CameraTest Alembic)
ADD_TEST(AbcGeom_Camera_TEST AbcGeom_CameraTest)

ADD_EXECUTABLE(playground PlayGround.cpp)
TARGET_LINK_LIBRARIES(playground Alembic)

file(COPY fuzzer_issue25695.abc DESTINATION .)

=== PKGBUILD ===
# Maintainer: Andrew Sun <adsun701@gmail.com>

_realname=alembic
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.8.5
pkgrel=2
pkgdesc="A open framework for storing and sharing scene data (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.alembic.io/"
msys2_repository_url="https://github.com/alembic/alembic"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-imath"
         "${MINGW_PACKAGE_PREFIX}-hdf5")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
             #"${MINGW_PACKAGE_PREFIX}-boost"
             #"${MINGW_PACKAGE_PREFIX}-python")
#optdepends=("${MINGW_PACKAGE_PREFIX}-boost: Python bindings"
#            "${MINGW_PACKAGE_PREFIX}-python: Python bindings")
source=("https://github.com/alembic/${_realname}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-alembic-1.7.9-fix-windows-build.patch"
        "0002-alembic-1.7.9-remove-msc_ver-and-fix-builtins-and-includes.patch")
sha256sums=('180a12f08d391cd89f021f279dbe3b5423b1db751a9898540c8059a45825c2e9'
            '81df673984894ec38b8a24aeb8d3f17a02b3aa697c2c943970b8984024ab9a64'
            '639eec0611f3f40a74003e58946f556e6e4e0a54c85f10bcda8c3da1b1de6a81')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  patch -Np1 -i "${srcdir}/0001-alembic-1.7.9-fix-windows-build.patch"
  patch -Np1 -i "${srcdir}/0002-alembic-1.7.9-remove-msc_ver-and-fix-builtins-and-includes.patch"
}

build() {
  # Static Build
  mkdir -p "${srcdir}"/build-${MSYSTEM}-static && cd "${srcdir}"/build-${MSYSTEM}-static

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  export OPENEXR_ROOT=${MINGW_PREFIX}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DUSE_HDF5=ON \
      -DUSE_STATIC_HDF5=ON \
      -DUSE_BINARIES=OFF \
      -DUSE_TESTS=OFF \
      -DALEMBIC_ILMBASE_LINK_STATIC=OFF \
      -DALEMBIC_SHARED_LIBS=OFF \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .

  # Shared Build
  mkdir -p "${srcdir}"/build-${MSYSTEM}-shared && cd "${srcdir}"/build-${MSYSTEM}-shared

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DUSE_HDF5=ON \
      -DUSE_PYALEMBIC=OFF \
      -DUSE_TESTS=OFF \
      -DALEMBIC_SHARED_LIBS=ON \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  # Static Install
  cd "${srcdir}"/build-${MSYSTEM}-static
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  # Shared Install
  cd "${srcdir}"/build-${MSYSTEM}-shared
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  local WINPREFIX=$(cygpath -wm ${MINGW_PREFIX})
  # Fix paths
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake" -type f -name '*.cmake' \
    -exec sed -i -e "s|${WINPREFIX}|\$\{_IMPORT_PREFIX\}|g" {} \;

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
